
require 'set'
# quick and dirty "Full text" indexer for fastsearch.
# works fine for small amounts of data

module Indexable

	def each_word
		each_sentence{|sen|
			sen.split(%r{[[:space:]]+|[[:punct:]]+}).each{|w| yield w }
		}
	end

	def each_wordstart
		each_word{|w| 
			wstart = ''
			w.downcase.each_char{|c|
				wstart << c
				yield wstart 
			}
		}	
	end

end



class SimpleIndex < Hash
	def compile(obj)
		obj.each_wordstart {|ws| 
			unless self.has_key?(ws)
				self[ws] = Set.new
			end
			self[ws].add(obj)
	}
	end
end
